// (C) 2003 D. Gauchard <deyv@free.fr>
// Licensed under the terms of the GNU Public License version 2

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

void help (char* name)
{
	printf("syntax: %s <filename> <string>\n", name);
}

int main (int argc, char* argv[])
{
	int f;
	off_t size;
	unsigned char* buf;
	off_t i;

	if (argc < 2)
	{
		help(argv[0]);
		return 1;
	}
	
	if ((f = open(argv[1], O_RDONLY)) == -1)
		perror(argv[1]);
	
	if ((size = lseek(f, 0, SEEK_END)) == -1)
	{
		perror("lseek(end)");
		close(f);
		return 1;
	}
	
	if (lseek(f, 0, SEEK_SET) == -1)
	{
		perror("lseek(begin)");
		close(f);
		return 1;
	}
	
	if ((buf = (unsigned char*)malloc(size)) == NULL)
	{
		fprintf(stderr, "cannot allocate %i bytes\n", (int)size);
		close(f);
		return 1;
	}
	
	if (read(f, buf, size) != size)
	{
		perror("File is not fully readable");
		close(f);
		return 1;
	}
	
	close(f);
	
	printf("/* This file is automatically generated */\n");
	for (i = 2; i < argc; i++)
		printf("%s ", argv[i]);
	printf("[%i] = {\n\t", (int)size+1);
	for (i = 0; i < size; i++)
	{
		printf("0x%02x, ", buf[i]);
		if ((i != (size - 1)) && !((i+1) % 16))
			printf("\n\t");
	}
	printf("0x00, \n};\n");

	return 0;
}
